//Defining classes
//Vulnerability
Vulnerability = {}
// Attributes
Vulnerability.portNumber = ""
Vulnerability.portStatus = ""
Vulnerability.portProtocol = ""
Vulnerability.libName = ""
Vulnerability.libVersion = ""
Vulnerability.LanIpAddress = ""
Vulnerability.ExternalIpAddress = ""
Vulnerability.vulnMemoryAddress = ""
Vulnerability.vulnType = "" //Buffer overflow
Vulnerability.vulnMethod = "" // copy string
Vulnerability.vulnUnsecValue = ""
Vulnerability.vulnOption = ""
Vulnerability.vulnConditions = []
// Methods
Vulnerability._toString = function ()
	res = self.LanIpAddress + ":" + self.portNumber + ":" + self.portProtocol + ":" + self.libVersion + ":" + self.vulnMemoryAddress + ":" + self.vulnType + ":" + self.vulnMethod + ":" + self.vulnUnsecValue + ":" + self.vulnOption
	conditionIndex = 0
	for cond in self.vulnConditions
		conditionIndex = conditionIndex + 1
		res = res + char(10) + "Condition "+ conditionIndex +": " + cond
	end for
	return res
end function

Vulnerability._getFilePath = function ()
	return globals.vulnerabilitiesDirectoryName + self.ExternalIpAddress + "/"
end function

Vulnerability._toFile = function ()
	myshell = get_shell

	fileName = self.libName + "_" + self.libVersion.replace(".","_")
	myshell.host_computer.touch(self._getFilePath, fileName)

	vulnerabilityFile = myshell.host_computer.File(self._getFilePath + fileName)
	vulnerabilityFile.set_content(vulnerabilityFile.content + char(10) + self._toString)
	return vulnerabilityFile
end function

Vulnerability._fromFile = function ()
	//ToDo
end function

Vulnerability._setExternalIpAddress = function(ipAddress)
	self.vulnConditions = []
	self.ExternalIpAddress = ipAddress
	myshell = get_shell
	myshell.host_computer.create_folder( globals.vulnerabilitiesDirectoryName, self.ExternalIpAddress)
end function

Vulnerability._setLibName = function(libName)
	self.libName = libName
end function

Vulnerability._setPortInfos = function(port)
	if (is_valid_ip(self.ExternalIpAddress) == false) then
		exit("<color=#FF0000FF>External Ip Address should be set before port.</color>")
	end if
	isLanIp = is_lan_ip(self.ExternalIpAddress)
	if (port != null and port != "router") then
		self.portNumber = port.port_number
		serviceInfos = globals.router.port_info(port).split(" ")
		self.portProtocol = serviceInfos[0]
		self.libVersion = serviceInfos[1]
		self.LanIpAddress = port.get_lan_ip
		self.portStatus = "open"
		if(port.is_closed and not isLanIp) then
			self.portStatus = "closed"
		end if
	else if (port == "router") then
		routerLib = getRouter(self.ExternalIpAddress)
		self.portNumber = 0
		serviceInfos = routerLib.lib_name
		self.portProtocol = "Kernel"
		self.libVersion = routerLib.version
		self.LanIpAddress = globals.router.local_ip
		self.portStatus = "N/A"
	end if
end function

Vulnerability._setVuln = function(memAddress, vulnText)
	self.vulnMemoryAddress = memAddress
	//print("Debug: text: " + vulnText)
	vulnTextLines = vulnText.split("###")
	//print("Debug: textafter split: " + vulnTextLines)
	for line in vulnTextLines
		if line.indexOf("Unsafe check") == 0 then
			//print("Debug: lineToPush1: " + line)
			self._parseVulnDesc(line)
		else if line.indexOf("* ") == 0 then
			lineToPush = line.remove("* ").remove(".")
			//print("Debug: lineToPush2: " + lineToPush)
			self.vulnConditions.push(lineToPush)
		else
			//print("unused line: " + line)
		end if
	end for
end function

//private
Vulnerability._parseVulnDesc = function(vulnDesc)
	vulnDesc = vulnDesc.remove("Unsafe check: ")
	vulnDescArray = vulnDesc.split(". ")
	self.vulnType = vulnDescArray[1].remove(".")
	lastSpaceIndex = vulnDescArray[0].lastIndexOf(" ")
	self.vulnMethod = vulnDescArray[0][0:lastSpaceIndex]
	self.vulnUnsecValue = slice(vulnDescArray[0],lastSpaceIndex+1).remove("<b>").remove("</b>")
end function

//END classes definitions
